// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.3.0
// - protoc             v4.23.3
// source: carInfo.proto

package proto

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

const (
	CarInfoService_GetCostOfCar_FullMethodName       = "/CarInfoService/GetCostOfCar"
	CarInfoService_GetCarMileage_FullMethodName      = "/CarInfoService/GetCarMileage"
	CarInfoService_RegistrationNewCar_FullMethodName = "/CarInfoService/RegistrationNewCar"
	CarInfoService_GetCarInfo_FullMethodName         = "/CarInfoService/GetCarInfo"
	CarInfoService_CreateCarInfo_FullMethodName      = "/CarInfoService/CreateCarInfo"
	CarInfoService_UpdateCarInfo_FullMethodName      = "/CarInfoService/UpdateCarInfo"
	CarInfoService_DeleteCarInfo_FullMethodName      = "/CarInfoService/DeleteCarInfo"
	CarInfoService_GetAllCarInfo_FullMethodName      = "/CarInfoService/GetAllCarInfo"
)

// CarInfoServiceClient is the client API for CarInfoService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type CarInfoServiceClient interface {
	GetCostOfCar(ctx context.Context, in *CarInfoRequest, opts ...grpc.CallOption) (*CostOfCar, error)
	GetCarMileage(ctx context.Context, in *CarInfoRequest, opts ...grpc.CallOption) (*Mileage, error)
	RegistrationNewCar(ctx context.Context, in *Car, opts ...grpc.CallOption) (*Car, error)
	GetCarInfo(ctx context.Context, in *CarInfoRequest, opts ...grpc.CallOption) (*CarInfo, error)
	CreateCarInfo(ctx context.Context, in *CarInfo, opts ...grpc.CallOption) (*CarInfo, error)
	UpdateCarInfo(ctx context.Context, in *CarInfo, opts ...grpc.CallOption) (*CarInfo, error)
	DeleteCarInfo(ctx context.Context, in *CarInfoRequest, opts ...grpc.CallOption) (*CarInfo, error)
	GetAllCarInfo(ctx context.Context, in *Empty, opts ...grpc.CallOption) (*CarInfoList, error)
}

type carInfoServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewCarInfoServiceClient(cc grpc.ClientConnInterface) CarInfoServiceClient {
	return &carInfoServiceClient{cc}
}

func (c *carInfoServiceClient) GetCostOfCar(ctx context.Context, in *CarInfoRequest, opts ...grpc.CallOption) (*CostOfCar, error) {
	out := new(CostOfCar)
	err := c.cc.Invoke(ctx, CarInfoService_GetCostOfCar_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *carInfoServiceClient) GetCarMileage(ctx context.Context, in *CarInfoRequest, opts ...grpc.CallOption) (*Mileage, error) {
	out := new(Mileage)
	err := c.cc.Invoke(ctx, CarInfoService_GetCarMileage_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *carInfoServiceClient) RegistrationNewCar(ctx context.Context, in *Car, opts ...grpc.CallOption) (*Car, error) {
	out := new(Car)
	err := c.cc.Invoke(ctx, CarInfoService_RegistrationNewCar_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *carInfoServiceClient) GetCarInfo(ctx context.Context, in *CarInfoRequest, opts ...grpc.CallOption) (*CarInfo, error) {
	out := new(CarInfo)
	err := c.cc.Invoke(ctx, CarInfoService_GetCarInfo_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *carInfoServiceClient) CreateCarInfo(ctx context.Context, in *CarInfo, opts ...grpc.CallOption) (*CarInfo, error) {
	out := new(CarInfo)
	err := c.cc.Invoke(ctx, CarInfoService_CreateCarInfo_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *carInfoServiceClient) UpdateCarInfo(ctx context.Context, in *CarInfo, opts ...grpc.CallOption) (*CarInfo, error) {
	out := new(CarInfo)
	err := c.cc.Invoke(ctx, CarInfoService_UpdateCarInfo_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *carInfoServiceClient) DeleteCarInfo(ctx context.Context, in *CarInfoRequest, opts ...grpc.CallOption) (*CarInfo, error) {
	out := new(CarInfo)
	err := c.cc.Invoke(ctx, CarInfoService_DeleteCarInfo_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *carInfoServiceClient) GetAllCarInfo(ctx context.Context, in *Empty, opts ...grpc.CallOption) (*CarInfoList, error) {
	out := new(CarInfoList)
	err := c.cc.Invoke(ctx, CarInfoService_GetAllCarInfo_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// CarInfoServiceServer is the server API for CarInfoService service.
// All implementations must embed UnimplementedCarInfoServiceServer
// for forward compatibility
type CarInfoServiceServer interface {
	GetCostOfCar(context.Context, *CarInfoRequest) (*CostOfCar, error)
	GetCarMileage(context.Context, *CarInfoRequest) (*Mileage, error)
	RegistrationNewCar(context.Context, *Car) (*Car, error)
	GetCarInfo(context.Context, *CarInfoRequest) (*CarInfo, error)
	CreateCarInfo(context.Context, *CarInfo) (*CarInfo, error)
	UpdateCarInfo(context.Context, *CarInfo) (*CarInfo, error)
	DeleteCarInfo(context.Context, *CarInfoRequest) (*CarInfo, error)
	GetAllCarInfo(context.Context, *Empty) (*CarInfoList, error)
	mustEmbedUnimplementedCarInfoServiceServer()
}

// UnimplementedCarInfoServiceServer must be embedded to have forward compatible implementations.
type UnimplementedCarInfoServiceServer struct {
}

func (UnimplementedCarInfoServiceServer) GetCostOfCar(context.Context, *CarInfoRequest) (*CostOfCar, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetCostOfCar not implemented")
}
func (UnimplementedCarInfoServiceServer) GetCarMileage(context.Context, *CarInfoRequest) (*Mileage, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetCarMileage not implemented")
}
func (UnimplementedCarInfoServiceServer) RegistrationNewCar(context.Context, *Car) (*Car, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RegistrationNewCar not implemented")
}
func (UnimplementedCarInfoServiceServer) GetCarInfo(context.Context, *CarInfoRequest) (*CarInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetCarInfo not implemented")
}
func (UnimplementedCarInfoServiceServer) CreateCarInfo(context.Context, *CarInfo) (*CarInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateCarInfo not implemented")
}
func (UnimplementedCarInfoServiceServer) UpdateCarInfo(context.Context, *CarInfo) (*CarInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateCarInfo not implemented")
}
func (UnimplementedCarInfoServiceServer) DeleteCarInfo(context.Context, *CarInfoRequest) (*CarInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteCarInfo not implemented")
}
func (UnimplementedCarInfoServiceServer) GetAllCarInfo(context.Context, *Empty) (*CarInfoList, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetAllCarInfo not implemented")
}
func (UnimplementedCarInfoServiceServer) mustEmbedUnimplementedCarInfoServiceServer() {}

// UnsafeCarInfoServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to CarInfoServiceServer will
// result in compilation errors.
type UnsafeCarInfoServiceServer interface {
	mustEmbedUnimplementedCarInfoServiceServer()
}

func RegisterCarInfoServiceServer(s grpc.ServiceRegistrar, srv CarInfoServiceServer) {
	s.RegisterService(&CarInfoService_ServiceDesc, srv)
}

func _CarInfoService_GetCostOfCar_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CarInfoRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CarInfoServiceServer).GetCostOfCar(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: CarInfoService_GetCostOfCar_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CarInfoServiceServer).GetCostOfCar(ctx, req.(*CarInfoRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _CarInfoService_GetCarMileage_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CarInfoRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CarInfoServiceServer).GetCarMileage(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: CarInfoService_GetCarMileage_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CarInfoServiceServer).GetCarMileage(ctx, req.(*CarInfoRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _CarInfoService_RegistrationNewCar_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Car)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CarInfoServiceServer).RegistrationNewCar(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: CarInfoService_RegistrationNewCar_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CarInfoServiceServer).RegistrationNewCar(ctx, req.(*Car))
	}
	return interceptor(ctx, in, info, handler)
}

func _CarInfoService_GetCarInfo_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CarInfoRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CarInfoServiceServer).GetCarInfo(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: CarInfoService_GetCarInfo_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CarInfoServiceServer).GetCarInfo(ctx, req.(*CarInfoRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _CarInfoService_CreateCarInfo_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CarInfo)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CarInfoServiceServer).CreateCarInfo(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: CarInfoService_CreateCarInfo_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CarInfoServiceServer).CreateCarInfo(ctx, req.(*CarInfo))
	}
	return interceptor(ctx, in, info, handler)
}

func _CarInfoService_UpdateCarInfo_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CarInfo)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CarInfoServiceServer).UpdateCarInfo(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: CarInfoService_UpdateCarInfo_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CarInfoServiceServer).UpdateCarInfo(ctx, req.(*CarInfo))
	}
	return interceptor(ctx, in, info, handler)
}

func _CarInfoService_DeleteCarInfo_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CarInfoRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CarInfoServiceServer).DeleteCarInfo(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: CarInfoService_DeleteCarInfo_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CarInfoServiceServer).DeleteCarInfo(ctx, req.(*CarInfoRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _CarInfoService_GetAllCarInfo_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CarInfoServiceServer).GetAllCarInfo(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: CarInfoService_GetAllCarInfo_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CarInfoServiceServer).GetAllCarInfo(ctx, req.(*Empty))
	}
	return interceptor(ctx, in, info, handler)
}

// CarInfoService_ServiceDesc is the grpc.ServiceDesc for CarInfoService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var CarInfoService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "CarInfoService",
	HandlerType: (*CarInfoServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetCostOfCar",
			Handler:    _CarInfoService_GetCostOfCar_Handler,
		},
		{
			MethodName: "GetCarMileage",
			Handler:    _CarInfoService_GetCarMileage_Handler,
		},
		{
			MethodName: "RegistrationNewCar",
			Handler:    _CarInfoService_RegistrationNewCar_Handler,
		},
		{
			MethodName: "GetCarInfo",
			Handler:    _CarInfoService_GetCarInfo_Handler,
		},
		{
			MethodName: "CreateCarInfo",
			Handler:    _CarInfoService_CreateCarInfo_Handler,
		},
		{
			MethodName: "UpdateCarInfo",
			Handler:    _CarInfoService_UpdateCarInfo_Handler,
		},
		{
			MethodName: "DeleteCarInfo",
			Handler:    _CarInfoService_DeleteCarInfo_Handler,
		},
		{
			MethodName: "GetAllCarInfo",
			Handler:    _CarInfoService_GetAllCarInfo_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "carInfo.proto",
}
